diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/model/global-route-manager-impl.cc ns-3.47/src/internet/model/global-route-manager-impl.cc
--- ns-3.46/src/internet/model/global-route-manager-impl.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/model/global-route-manager-impl.cc	2026-02-16 16:08:49.611230000 -0800
@@ -2143,4 +2295,387 @@
     }
 }
 
+template <typename T>
+Ptr<Node>
+GlobalRouteManagerImpl<T>::GetNodeByIp(const IpAddress& address)
+{
+    // iterate through the list of nodes
+    for (auto i = NodeList::Begin(); i != NodeList::End(); ++i)
+    {
+        Ptr<Node> node = *i;
+        Ptr<Ip> ip = node->GetObject<Ip>();
+
+        if (!ip)
+        {
+            continue;
+        }
+
+        int32_t interface = ip->GetInterfaceForAddress(address);
+        if (interface >= 0) // Address found on this node
+        {
+            return node;
+        }
+    }
+    return nullptr; // If no node with the given IP address was found
+}
+
+template <typename T>
+void
+GlobalRouteManagerImpl<T>::PrintRoute(Ptr<Node> sourceNode,
+                                      Ptr<Node> dest,
+                                      Ptr<OutputStreamWrapper> stream,
+                                      bool nodeIdLookup,
+                                      Time::Unit unit)
+{
+    // Get any Ip of destination other than the loopbackIp
+    Ptr<Ip> ip = dest->GetObject<Ip>();
+    NS_ASSERT_MSG(ip, "Ip not found on destination node " << dest->GetId());
+
+    uint32_t numInterfaces = ip->GetNInterfaces();
+
+    for (uint32_t i = 0; i < numInterfaces; i++)
+    {
+        uint32_t numAddresses = ip->GetNAddresses(i);
+        for (uint32_t j = 0; j < numAddresses; j++)
+        {
+            IpInterfaceAddress addr = ip->GetAddress(i, j);
+            IpAddress localAddr;
+            if constexpr (IsIpv4)
+            {
+                localAddr = addr.GetLocal();
+            }
+            else
+            {
+                localAddr = addr.GetAddress();
+            }
+            if (localAddr != IpAddress::GetLoopback())
+            {
+                PrintRoute(sourceNode, localAddr, stream, nodeIdLookup, unit);
+                return;
+            }
+        }
+    }
+    // If no IP address is associated with the destination node, abort the program
+    NS_ABORT_MSG("No IP address associated with destination Node");
+}
+
+template <typename T>
+Ptr<typename GlobalRouteManagerImpl<T>::IpGlobalRouting>
+GlobalRouteManagerImpl<T>::GetGlobalRoutingForNode(Ptr<Node> node)
+{
+    Ptr<Ip> ip = node->GetObject<Ip>();
+    auto globalRouting = DynamicCast<IpGlobalRouting>(ip->GetRoutingProtocol());
+
+    if (globalRouting)
+    {
+        return globalRouting;
+    }
+
+    auto list = DynamicCast<IpListRouting>(ip->GetRoutingProtocol());
+    if (!list)
+    {
+        return nullptr;
+    }
+
+    for (uint32_t i = 0; i < list->GetNRoutingProtocols(); i++)
+    {
+        int16_t priority = 0;
+        globalRouting = DynamicCast<IpGlobalRouting>(list->GetRoutingProtocol(i, priority));
+        if (globalRouting)
+        {
+            return globalRouting;
+        }
+    }
+
+    return nullptr;
+}
+
+template <typename T>
+bool
+GlobalRouteManagerImpl<T>::IsLocalDelivery(Ptr<Ip> ip, IpAddress dest)
+{
+    for (uint32_t i = 0; i < ip->GetNInterfaces(); i++)
+    {
+        for (uint32_t j = 0; j < ip->GetNAddresses(i); j++)
+        {
+            auto addr = ip->GetAddress(i, j);
+            IpAddress localAddr;
+            if constexpr (IsIpv4)
+            {
+                localAddr = addr.GetLocal();
+            }
+            else
+            {
+                localAddr = addr.GetAddress();
+            }
+            if (dest == localAddr)
+            {
+                return true;
+            }
+        }
+    }
+
+    return false;
+}
+
+template <typename T>
+bool
+GlobalRouteManagerImpl<T>::ValidateSourceNodeHasIpAddress(Ptr<Ip> ip)
+{
+    uint32_t numInter = ip->GetNInterfaces();
+    if (numInter == 0)
+    {
+        NS_ABORT_MSG("No interfaces associated with source Node");
+        return false;
+    }
+
+    for (uint32_t i = 0; i < numInter; i++)
+    {
+        if (ip->GetNAddresses(i) > 0)
+        {
+            return true;
+        }
+    }
+
+    NS_ABORT_MSG("No IP address associated with source Node");
+    return false;
+}
+
+template <typename T>
+bool
+GlobalRouteManagerImpl<T>::IsOnSameSubnet(Ptr<Ip> ipCurrentNode, IpAddress dest)
+{
+    bool found = false;
+    uint32_t numInterfaces = ipCurrentNode->GetNInterfaces();
+    for (uint32_t i = 0; i < numInterfaces; i++)
+    {
+        uint32_t numAddresses = ipCurrentNode->GetNAddresses(i);
+        for (uint32_t j = 0; j < numAddresses; j++)
+        {
+            IpInterfaceAddress senderAddr = ipCurrentNode->GetAddress(i, j);
+            // Check if the destination is within the same subnet
+            if constexpr (IsIpv4)
+            {
+                IpMaskOrPrefix mask = senderAddr.GetMask();
+                if (mask.IsMatch(dest, senderAddr.GetLocal()))
+                {
+                    // next hop will be the destNode
+                    return true;
+                }
+            }
+            else
+            {
+                IpMaskOrPrefix prefix = senderAddr.GetPrefix();
+                if (prefix.IsMatch(dest, senderAddr.GetAddress()))
+                {
+                    // next hop will be the destNode
+                    return true;
+                }
+            }
+        }
+    }
+    return found;
+}
+
+template <typename T>
+void
+GlobalRouteManagerImpl<T>::PrintRoute(Ptr<Node> sourceNode,
+                                      IpAddress dest,
+                                      Ptr<OutputStreamWrapper> stream,
+                                      bool nodeIdLookup,
+                                      Time::Unit unit)
+{
+    NS_LOG_FUNCTION(this << sourceNode << dest);
+
+    Ptr<Node> destNode = GetNodeByIp(dest);
+    // check that given ip address exists
+    if (!destNode)
+    {
+        NS_ABORT_MSG("Destination node not found for IP address: " << dest);
+        return;
+    }
+
+    NS_ABORT_MSG_IF(!sourceNode, "No Source Node Provided");
+    Ptr<Ip> ip = sourceNode->GetObject<Ip>();
+    // check for ip stack
+    NS_ABORT_MSG_IF(!ip, "No Ip object found on source node " << sourceNode->GetId());
+
+    // check if source has ip address assigned to it
+    if (!ValidateSourceNodeHasIpAddress(ip))
+    {
+        NS_ABORT_MSG("No IP address associated with source Node");
+        return;
+    }
+
+    auto globalRouting = GetGlobalRoutingForNode(sourceNode);
+
+    // Final check: If still nullptr, GlobalRouting wasn't found anywhere
+    if (!globalRouting)
+    {
+        NS_ABORT_MSG("No global routing protocol found on source node " << sourceNode->GetId());
+        return;
+    }
+
+    // Set up the output stream
+    std::ostream* os = stream->GetStream();
+    uint32_t hopsRemaining = 64;
+    uint32_t currHop = 1;
+    // Print the maxHop. This is similar to TraceRoute
+    *os << ", " << hopsRemaining << " hops Max." << std::endl;
+
+    // first check if it is local delivery to one of the nodes on the source node itself
+    if (IsLocalDelivery(ip, dest))
+    {
+        NS_LOG_DEBUG("PrintRoute: Source and Destination are on the same Node "
+                     << sourceNode->GetId());
+        *os << "Source and Destination are on the same Node";
+        *os << std::endl << std::endl;
+        return;
+    }
+
+    // check if routes exist
+    if (!globalRouting->LookupGlobal(dest))
+    {
+        *os << "There is no path from Node " << sourceNode->GetId() << " to Node "
+            << destNode->GetId() << "." << std::endl
+            << std::endl;
+        return;
+    }
+
+    // we start searching for gateways
+    Ptr<Node> currentNode = sourceNode;
+    IpAddress currentNodeIp;
+    std::list<Ptr<Node>> visitedNodes;
+    visitedNodes.push_back(currentNode);
+    while (currentNode != destNode)
+    {
+        if (!hopsRemaining)
+        {
+            NS_LOG_WARN("Max Hop Limit reached");
+            return;
+        }
+
+        Ptr<Ip> ipCurrentNode = currentNode->GetObject<Ip>();
+        auto router = GetGlobalRoutingForNode(currentNode);
+
+        Ptr<IpRoute> gateway = router->LookupGlobal(dest);
+        // check if the gateway exists
+        if (!gateway)
+        {
+            NS_LOG_WARN("No next hop found");
+            return;
+        }
+
+        IpAddress gatewayAddress = gateway->GetGateway();
+
+        // check if the currentNode and the destination belong to the same network. Routing tables
+        // will have a routing table entry with 0.0.0.0 (or ::) as Gateway
+        if (gatewayAddress == IpAddress::GetZero())
+        {
+            // check if gateway is on the same subnet as the destination if it is not and still null
+            // then there is no next jump
+            bool found = IsOnSameSubnet(ipCurrentNode, dest);
+            if (!found)
+            {
+                *os << "Error: Did not find any addresses for  " << dest << " From "
+                    << currentNode->GetId() << std::endl;
+                return;
+            }
+            else
+            {
+                currentNode = destNode;
+                break;
+            }
+        }
+
+        Ptr<Node> nextNode = GetNodeByIp(gatewayAddress);
+
+        if (nextNode == currentNode)
+        {
+            *os << "Invalid route: Next hop points back to the current node (Node "
+                << currentNode->GetId() << ").\n";
+            NS_LOG_WARN("Invalid route: Next hop points back to the current node.");
+            return;
+        }
+
+        // check for loops
+        if (std::find(visitedNodes.begin(), visitedNodes.end(), nextNode) != visitedNodes.end())
+        {
+            *os << "Loop detected! Node " << nextNode->GetId() << " revisited.\n\n";
+            NS_LOG_WARN("Routing Loop detected");
+            return;
+        }
+        visitedNodes.push_back(nextNode);
+
+        Ptr<NetDevice> outdevice = gateway->GetOutputDevice();
+        Ptr<IpL3Protocol> ipL3 = currentNode->GetObject<IpL3Protocol>();
+        uint32_t interfaceIndex = ipCurrentNode->GetInterfaceForDevice(outdevice);
+        currentNodeIp = ipL3->SourceAddressSelection(interfaceIndex, gatewayAddress);
+
+        // print this iteration
+        std::ostringstream addr;
+        std::ostringstream node;
+        if (nextNode != destNode)
+        {
+            node << "(Node " << nextNode->GetId() << ")";
+            addr << gatewayAddress;
+            *os << std::right << std::setw(2) << currHop++ << "  " << addr.str();
+            if (nodeIdLookup)
+            {
+                *os << " " << node.str();
+            }
+            *os << std::endl;
+        }
+        // if the next node is the destination node, then print the Destination IP instead of the
+        // ingress IP of the destination.
+        else
+        {
+            node << "(Node " << destNode->GetId() << ")";
+            addr << dest;
+            *os << std::right << std::setw(2) << currHop++ << "  " << addr.str();
+            if (nodeIdLookup)
+            {
+                *os << " " << node.str();
+            }
+            *os << std::endl;
+        }
+        currentNode = nextNode;
+        currentNodeIp = gatewayAddress;
+        hopsRemaining--;
+    }
+    *os << std::endl;
+}
+
+template <typename T>
+void
+GlobalRouteManagerImpl<T>::InitializeRouters()
+{
+    NS_LOG_FUNCTION_NOARGS();
+    for (auto i = NodeList::Begin(); i != NodeList::End(); i++)
+    {
+        Ptr<Node> node = *i;
+        Ptr<Ip> ip = node->GetObject<Ip>();
+        if (!ip)
+        {
+            continue;
+        }
+        if constexpr (!IsIpv4)
+        {
+            ip->SetAttribute("StrongEndSystemModel", BooleanValue(false));
+        }
+
+        for (uint32_t i = 0; i < ip->GetNInterfaces(); i++)
+        {
+            ip->SetForwarding(i, true);
+        }
+    }
+}
+
+template class SPFVertex<Ipv4Manager>;
+template class GlobalRouteManagerLSDB<Ipv4Manager>;
+template class ns3::GlobalRouteManagerImpl<ns3::Ipv4Manager>;
+template class SPFVertex<Ipv6Manager>;
+template class GlobalRouteManagerLSDB<Ipv6Manager>;
+template class ns3::GlobalRouteManagerImpl<ns3::Ipv6Manager>;
+
 } // namespace ns3
